﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace RadTreeListView_WPF
{
	/// <summary>
	/// A football player.
	/// </summary>
	public class Player : INotifyPropertyChanged
	{
		public event PropertyChangedEventHandler PropertyChanged;

		private string name;
		private int number;
		private string country;
		private int descriptionID;
		private bool isChampion;

		public string Name
		{
			get { return this.name; }
			set
			{
				if (value != this.name)
				{
					this.name = value;
					this.OnPropertyChanged("Name");
				}
			}
		}

		public int Number
		{
			get { return this.number; }
			set
			{
				if (value != this.number)
				{
					this.number = value;
					this.OnPropertyChanged("Number");
				}
			}
		}

		public string Country
		{
			get { return this.country; }
			set
			{
				if (value != this.country)
				{
					this.country = value;
					this.OnPropertyChanged("Country");
				}
			}
		}
		public int DescriptionID
		{
			get { return this.descriptionID; }
			set
			{
				if (value != this.descriptionID)
				{
					this.descriptionID = value;
					this.OnPropertyChanged("DescriptionID");
				}
			}
		}
		public bool IsChampion
		{
			get
			{
				return this.isChampion;
			}
			set
			{
				if (value != this.isChampion)
				{
					this.isChampion = value;
					this.OnPropertyChanged("IsChampion");
				}
			}
		}

		public Player()
		{

		}

		public Player(string name, int number, string country, int descriptionID, bool isChampion)
		{
			this.name = name;
			this.number = number;
			this.country = country;
			this.descriptionID = descriptionID;
			this.isChampion = isChampion;
		}

		protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
		{
			PropertyChangedEventHandler handler = this.PropertyChanged;
			if (handler != null)
			{
				handler(this, args);
			}
		}

		private void OnPropertyChanged(string propertyName)
		{
			this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
		}

		public override string ToString()
		{
			return this.Name;
		}

		public static ObservableCollection<Player> GetPlayers()
		{
			return new ObservableCollection<Player>(Club.GetClubs().SelectMany(c => c.Players));
		}
	}
}
